#!/usr/bin/perl
# $Id: magic.pl,v 1.7 1996/08/25 23:05:16 asf Exp $

#    This file is part of Addventure
#    Copyright (C) 1994, 1995  Allen S. Firstenberg
# 
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
# 
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
# 
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

###########################################################################

sub setting {
    local( $path ) = @_;
    local( $file ) = "$path" . "/options.addv";

    open( SETTING, $file );
    while( <SETTING> ){
	if( /^#.*$/ ){
	   # It's a comment
       } elsif( /^([-\w]*)\s*=\s*(.*)$/ ){
	   $setting{$1} = $2;
       } else {
	   # It's blank?
       }
    }
    close( SETTING );

    foreach $key (keys %setting){
	$var = $key;
	$var =~ s/-/_/g;
	*ptr = $var;
	$ptr = $setting{$key};
    }
}

sub process {
    local ($arg) = @_;
    $arg =~ s/\@/\\\@/g;
    $arg =~ s/"/\\"/g;
    $command = "print \"" . $arg . "\"";
    eval( $command );
}

&setting( $ENV{"PATH_TRANSLATED"} );

@path = split( /\//, $ENV{"SCRIPT_NAME"} );
$file = pop( @path );
$path = join( "/", @path );
$DocPre  = $path . "/";
$DocPost = $ENV{"PATH_INFO"};

&process( <<'</HTML>' . '</HTML>' ); # Insert header and HTML following
Content-type: text/html

